// NetSDKDemo.cpp : 定义应用程序的类行为。
//

#include "stdafx.h"
#include "NetSDKDemo.h"
#include "NetSDKDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CNetSDKDemoApp

BEGIN_MESSAGE_MAP(CNetSDKDemoApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CNetSDKDemoApp 构造

CNetSDKDemoApp::CNetSDKDemoApp()
{
	// TODO: 在此处添加构造代码，
	// 将所有重要的初始化放置在 InitInstance 中
	InitializeCriticalSection(&m_csCMap);

}

CNetSDKDemoApp::~CNetSDKDemoApp()
{
	ClearMap();
	DeleteCriticalSection(&m_csCMap);
}

// 唯一的一个 CNetSDKDemoApp 对象

CNetSDKDemoApp theApp;


// CNetSDKDemoApp 初始化

BOOL CNetSDKDemoApp::InitInstance()
{
	// 如果一个运行在 Windows XP 上的应用程序清单指定要
	// 使用 ComCtl32.dll 版本 6 或更高版本来启用可视化方式，
	//则需要 InitCommonControlsEx()。否则，将无法创建窗口。
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// 将它设置为包括所有要在应用程序中使用的
	// 公共控件类。
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// 标准初始化
	// 如果未使用这些功能并希望减小
	// 最终可执行文件的大小，则应移除下列
	// 不需要的特定初始化例程
	// 更改用于存储设置的注册表项
	// TODO: 应适当修改该字符串，
	// 例如修改为公司或组织名
	SetRegistryKey(_T("应用程序向导生成的本地应用程序"));

	CNetSDKDemoDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: 在此处放置处理何时用“确定”来关闭
		//  对话框的代码
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: 在此放置处理何时用“取消”来关闭
		//  对话框的代码
	}

	// 由于对话框已关闭，所以将返回 FALSE 以便退出应用程序，
	//  而不是启动应用程序的消息泵。
	return FALSE;
}

void CNetSDKDemoApp::ClearMap()
{
	CMapAutoLock MapLock;
	POSITION pos = m_DevList.GetStartPosition();
	while (pos)
	{
		CString strKey;
		CDevInfo *pDevInfo = NULL;
		m_DevList.GetNextAssoc(pos, strKey, pDevInfo);
		SAFE_DELETE(pDevInfo);
	}

	m_MSGDevList.Event_Clear();
}

SDKMSGList::SDKMSGList()
{
	InitializeCriticalSection(&m_cs);
}

SDKMSGList::~SDKMSGList()
{
	Event_Clear();
	DeleteCriticalSection(&m_cs);
}

void SDKMSGList::Event_AddTail(CSDKEvent *pEvent)
{
	if (pEvent)
	{
		EnterCriticalSection(&m_cs);
		if (m_MSGList.GetCount() > 1000)
		{
			CSDKEvent *pEvnet = m_MSGList.RemoveHead();
			SAFE_DELETE(pEvnet);
		}
		m_MSGList.AddTail(pEvent);
		LeaveCriticalSection(&m_cs);
	}
}

CSDKEvent* SDKMSGList::Event_RemoveHead()
{
	CSDKEvent *pEvent = NULL;
	EnterCriticalSection(&m_cs);
	if (!m_MSGList.IsEmpty())
	{
		pEvent = m_MSGList.RemoveHead();
	}
	LeaveCriticalSection(&m_cs);

	return pEvent;
}

void SDKMSGList::Event_Clear()
{
	CSDKEvent *pEvent = NULL;
	EnterCriticalSection(&m_cs);
	while (!m_MSGList.IsEmpty())
	{
		pEvent = m_MSGList.RemoveHead();
		SAFE_DELETE(pEvent);
	}
	LeaveCriticalSection(&m_cs);

}